#include <stdio.h>
#include <wchar.h>
#include <irrlicht.h>
#include <iostream>
#include <stdlib.h>
#include <time.h>

using namespace irr;
bool UP=false; // Przycisk na gur
bool DOWN=false; // Przycisk na d
bool RIGHT=false; // Przycisk na prawo
bool LEFT=false; // Przycisk na lewo
bool JUMP=false; // Przycisk do skoku
bool ESC=false; // Wyjscie z gry
double speed=0.08; // szybko
double speedW=0.05; // szybkosc wroga
double Jump=0; // Skok
int TIME=1000;
int Score=0;
int wDir=0;

double SB=5;

#pragma comment(lib, "Irrlicht.lib")

scene::ISceneNode* node=0;
scene::ISceneNode* node2=0;
scene::ISceneNode* nodeS=0;
scene::ISceneNode* nodeW=0;
IrrlichtDevice* device=0;

class KeyboardGet : public IEventReceiver
{
   public:
   virtual bool OnEvent(SEvent event)
   {
      if (event.EventType == irr::EET_KEY_INPUT_EVENT)
      {
         switch(event.KeyInput.Key)
         {
            case KEY_KEY_W:
               UP=event.KeyInput.PressedDown;
         break;
            case KEY_KEY_S:
              DOWN=event.KeyInput.PressedDown;
         break;
            case KEY_KEY_D:
              RIGHT=event.KeyInput.PressedDown;
         break;
            case KEY_KEY_A:
              LEFT=event.KeyInput.PressedDown;
         break;
            case KEY_SPACE:
              JUMP=event.KeyInput.PressedDown;
         break;
            case KEY_ESCAPE:
              ESC=event.KeyInput.PressedDown;
         break;
         }
         return true;
      }
      return false;
   }
};

int main()
{
   KeyboardGet receiver;

   device=createDevice(video::EDT_OPENGL,core::dimension2d<s32>(640,480),
     16,false,false,false,&receiver);

   video::IVideoDriver* driver=device->getVideoDriver();
   scene::ISceneManager* smgr=device->getSceneManager();

//         SWIATLO
   node2=smgr->addLightSceneNode(0,core::vector3df(0,80,0),video::SColor(255,255,255,255),100.0f);
//         KAMERA
   smgr->addCameraSceneNode(0,core::vector3df(0,100,0),core::vector3df(0,0,0));


//         Punkty
   nodeS=smgr->addSphereSceneNode();
   nodeS->setScale(core::vector3df(0.5,0.5,0.5));
   srand( (unsigned)time( NULL ) ); // "wymieszaj"
   int a=rand() % 120;
   int b=rand() % 140;
   int c=rand() % 10;
   nodeS->setPosition(core::vector3df(a-60,c,b-70));
   nodeS->setMaterialTexture(0,driver->getTexture("./gfx/Score.jpg"));
   nodeS->setMaterialFlag(video::EMF_LIGHTING,true);
//         WROG
   nodeW=smgr->addCubeSceneNode();
   nodeW->setPosition(core::vector3df(0,0,0));
   nodeW->setScale(core::vector3df(1,1,1));
   nodeW->setMaterialTexture(0,driver->getTexture("./gfx/enemy.jpg"));
   nodeW->setMaterialFlag(video::EMF_LIGHTING,true);
//         GRACZ
   node=smgr->addCubeSceneNode();
   node->setPosition(core::vector3df(999,0,999));
   node->setScale(core::vector3df(1,1,1));
   node->setMaterialTexture(0,driver->getTexture("./gfx/Player.jpg"));
   node->setMaterialFlag(video::EMF_LIGHTING,true);
//         PODLOGA
   node2=smgr->addCubeSceneNode();
   node2->setScale(core::vector3df(15,1,20));
   node2->setPosition(core::vector3df(0,-10,0));
   node2->setMaterialTexture(0,driver->getTexture("./gfx/Floor.jpg"));
   node2->setMaterialFlag(video::EMF_LIGHTING,true);
//         GORNA SCANA
   node2=smgr->addCubeSceneNode();
   node2->setScale(core::vector3df(1,15,20));
   node2->setPosition(core::vector3df(70,10,0));
   node2->setMaterialTexture(0,driver->getTexture("./gfx/wall.jpg"));
   node2->setMaterialFlag(video::EMF_LIGHTING,true);

//         DOLNA SCANA
   node2=smgr->addCubeSceneNode();
   node2->setScale(core::vector3df(1,15,20));
   node2->setPosition(core::vector3df(-70,10,0));
   node2->setMaterialTexture(0,driver->getTexture("./gfx/wall.jpg"));
   node2->setMaterialFlag(video::EMF_LIGHTING,true);
//         PRAWA SCANA
   node2=smgr->addCubeSceneNode();
   node2->setScale(core::vector3df(15,15,1));
   node2->setPosition(core::vector3df(0,10,90));
   node2->setMaterialTexture(0,driver->getTexture("./gfx/wall.jpg"));
   node2->setMaterialFlag(video::EMF_LIGHTING,true);
//         LEWA SCANA
   node2=smgr->addCubeSceneNode();
   node2->setScale(core::vector3df(15,15,1));
   node2->setPosition(core::vector3df(0,10,-90));
   node2->setMaterialTexture(0,driver->getTexture("./gfx/wall.jpg"));
   node2->setMaterialFlag(video::EMF_LIGHTING,true);


   int lastFPS=-1;
   while(device->run())
   {
      if (ESC) { device->drop(); return 0; }

      core::vector3df v=node->getPosition();
      core::vector3df s=nodeS->getPosition();
      core::vector3df w=nodeW->getPosition();
      if (v.Y<0) { v.Y=0; Jump=0; }
      if(UP || DOWN || RIGHT || LEFT)
      {
      if (DOWN) { v.X-=speed; }
      if (UP) { v.X+=speed; }
      if (RIGHT) { v.Z-=speed; }
      if (LEFT) { v.Z+=speed; }
      }

if(v.X>s.X-5 && v.X<s.X+5 && v.Y>s.Y-5 && v.Y<s.Y+5 && v.Z>s.Z-5 && v.Z<s.Z+5)
{
   int a=rand() % 120;
   int b=rand() % 140;
   int c=rand() % 16;
   s.X=a-60;
   s.Z=b-70;
   s.Y=c;
   Score+=1;
}

if(v.X>w.X-10 && v.X<w.X+10 && v.Y>w.Y-10 && v.Y<w.Y+10 && v.Z>w.Z-10 && v.Z<w.Z+10)
{
   int a=rand() % 120;
   int b=rand() % 140;
   int c=40;
   Jump=0;
   v.X=a-60;
   v.Z=b-70;
   v.Y=c;
   Score-=1;
}

      if (JUMP&&v.Y==0) { Jump=0.2; }
      Jump-=0.0008;
      v.Y+=Jump;
      if (v.Z>80)
      {
         v.Z=80;
      }
      if (v.X>60)
      {
         v.X=60;
      }
            if (v.Z<-80)
      {
         v.Z=-80;
      }
      if (v.X<-60)
      {
         v.X=-60;
      }

      if (w.Z>80)
      {
         w.Z=80;
         wDir=rand()%3;
      }
      if (w.X>60)
      {
         w.X=60;
         wDir=rand()%3;
      }
      if (w.Z<-80)
      {
         w.Z=-80;
         wDir=rand()%3;
      }
      if (w.X<-60)
      {
         w.X=-60;
         wDir=rand()%3;
      }

      if(wDir==0){ w.X+=speedW; }
      if(wDir==1){ w.X-=speedW; }
      if(wDir==2){ w.Z+=speedW; }
      if(wDir==3){ w.Z-=speedW; }

      node->setPosition(v);
      nodeS->setPosition(s);
      nodeW->setPosition(w);

      driver->beginScene(true,true,video::SColor(0,0,0,0));
      smgr->drawAll();
      driver->endScene();

      TIME-=1;
      if(TIME<0) { wDir=rand()%3; ++wDir; TIME=1000; }

      int fps=driver->getFPS();
      if(lastFPS!=fps)
      {
         core::stringw str=L"FPS: ";
         str+=fps;
         str+=" Score: ";
         str+=Score;
         device->setWindowCaption(str.c_str());
      }
   }
   device->drop();
   return 0;
}
